/*
 * servo.c
 *
 *  Created on: Dec 27, 2011
 *      Author: erlkoenig
 */

#include "stm32f4xx.h"
#include "servo.h"

void Servo4x_Init_Int (TIM_TypeDef* TIMx) {
	// TimeBase
	TIM_TimeBaseInitTypeDef timBase;

	TIM_TimeBaseStructInit (&timBase);
	timBase.TIM_Prescaler = ((SystemCoreClock / 2 ) / 1000000)-1;						// 10 kHz
	timBase.TIM_ClockDivision = TIM_CKD_DIV1;
	timBase.TIM_CounterMode = TIM_CounterMode_Up;
	timBase.TIM_Period = 20000;
	TIM_TimeBaseInit (TIM4, &timBase);
	TIM_ARRPreloadConfig (TIM4, ENABLE);

	// Update registers
	TIM4->EGR |= (1 << TIM_EGR_UG);

	// Output compare match
	TIM_OCInitTypeDef oc;
	TIM_OCStructInit (&oc);

	oc.TIM_OCIdleState = TIM_OCIdleState_Reset;
	oc.TIM_OCNIdleState = TIM_OCNIdleState_Set;
	oc.TIM_OCMode = TIM_OCMode_PWM1;
	oc.TIM_OCPolarity = TIM_OCPolarity_High;
	oc.TIM_OutputState = TIM_OutputState_Enable;
	oc.TIM_Pulse = 1500;

	TIM_OC1Init (TIMx, &oc);
	TIM_OC1PreloadConfig (TIMx, TIM_OCPreload_Enable);

	TIM_OC2Init (TIMx, &oc);
	TIM_OC2PreloadConfig (TIMx, TIM_OCPreload_Enable);

	TIM_OC3Init (TIMx, &oc);
	TIM_OC3PreloadConfig (TIMx, TIM_OCPreload_Enable);

	TIM_OC4Init (TIMx, &oc);
	TIM_OC4PreloadConfig (TIMx, TIM_OCPreload_Enable);

	TIM_BDTRInitTypeDef bdtr;
	TIM_BDTRStructInit (&bdtr);
	bdtr.TIM_AutomaticOutput = TIM_AutomaticOutput_Enable;
	TIM_BDTRConfig (TIM4, &bdtr);

	// Start the timer
	TIM_Cmd (TIMx, ENABLE);
}

void Servo4x_DeInit (TIM_TypeDef* TIMx) {
	TIM_Cmd (TIMx, DISABLE);
	TIM_DeInit (TIMx);
}
