/*
 * servo.h
 *
 *  Created on: Dec 27, 2011
 *      Author: erlkoenig
 */

#ifndef SERVO_H_
#define SERVO_H_

#ifdef __cplusplus
 extern "C" {
#endif

void Servo4x_Init_Int (TIM_TypeDef* TIMx);
void Servo4x_DeInit (TIM_TypeDef* TIMx);

#define Servo4x_Init(TIMx) RCC_APB1PeriphClockCmd(RCC_APB1Periph_##TIMx, ENABLE); Servo4x_Init_Int (TIMx);
#define Servo4x_Set1(TIMx,us) (TIM_SetCompare1((TIMx),(us)))
#define Servo4x_Set2(TIMx,us) (TIM_SetCompare2((TIMx),(us)))
#define Servo4x_Set3(TIMx,us) (TIM_SetCompare3((TIMx),(us)))
#define Servo4x_Set4(TIMx,us) (TIM_SetCompare4((TIMx),(us)))

#define Servo4x_Set_Pin(TIMx,port,pin) \
	{ RCC_AHB1PeriphClockCmd(RCC_AHB1ENR_GPIO##port##EN, ENABLE); \
	GPIO_InitTypeDef GPIO_InitStructure; \
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_##pin; \
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF; \
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; \
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP; \
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; \
	GPIO_Init(GPIO##port, &GPIO_InitStructure); \
	GPIO_PinAFConfig (GPIO##port, GPIO_PinSource##pin, GPIO_AF_##TIMx); }

#ifdef __cplusplus
 };
#endif

#endif /* SERVO_H_ */
