/*
 * t_accel.h
 *
 *  Created on: Dec 27, 2011
 *      Author: erlkoenig
 */

#ifndef T_ACCEL_H_
#define T_ACCEL_H_

#ifdef __cplusplus
 extern "C" {
#endif

#define TACCEL_REG_X (0x29)
#define TACCEL_REG_Y (0x2B)
#define TACCEL_REG_Z (0x2D)

#define TACCEL_BUF_SIZ (100)

typedef struct {
	int8_t buffer [3*TACCEL_BUF_SIZ];
	uint16_t fill;
	uint8_t state;
	uint8_t starting;
	int8_t x_off, y_off, z_off;
} TAccel;

extern TAccel theAccel;

int8_t TAccelInit ();
void TAccelDeInit ();
uint8_t TAccelRegRead (uint8_t address);
void TAccelRegWrite (uint8_t address, uint8_t data);
void TAccelRegReadAsyncQry (uint8_t ddress);
int8_t TAccelReadAsyncFetchI();
uint8_t TAccelReadAsyncFetch();

void TAccelRead (int* x, int* y, int* z);

#ifdef __cplusplus
 };
#endif


#endif /* T_ACCEL_H_ */
